const nameOfNode = 'machineGroupControl'; // this is the name of the node, it should match the file name and the node type in Node-RED
const nodeClass = require('./src/nodeClass.js'); // this is the specific node class
const { MenuManager, configManager } = require('generalFunctions');

// This is the main entry point for the Node-RED node, it will register the node and setup the endpoints
module.exports = function(RED) {
  // Register the node type
  RED.nodes.registerType(nameOfNode, function(config) {
    // Initialize the Node-RED node first
    RED.nodes.createNode(this, config);
    // Then create your custom class and attach it
    this.nodeClass = new nodeClass(config, RED, this, nameOfNode);
  });

  // Setup admin UIs
  const menuMgr = new MenuManager(); //this will handle the menu endpoints so we can load them dynamically
  const cfgMgr = new configManager(); // this will handle the config endpoints so we can load them dynamically

  // Register the different menu's for the node
  RED.httpAdmin.get(`/${nameOfNode}/menu.js`, (req, res) => {
    try {
      const script = menuMgr.createEndpoint(nameOfNode, ['logger','position']);
      res.type('application/javascript').send(script);
    } catch (err) {
      res.status(500).send(`// Error generating menu: ${err.message}`);
    }
  });

  // Endpoint to get the configuration data for the specific node
  RED.httpAdmin.get(`/${nameOfNode}/configData.js`, (req, res) => {
    try {
      const script = cfgMgr.createEndpoint(nameOfNode);
      // Send the configuration data as JSON response
      res.type('application/javascript').send(script);
    } catch (err) {
      res.status(500).send(`// Error generating configData: ${err.message}`);
    }
  });
};